// Get Present Position
//  Torque off and get present position
//  Since software serial is selected, dynamixel should be use at 57600bps or less.
//  1.select [SOFT]
//  2.compile & download

#include <dxlib.h>
#include <SoftwareSerial.h>

DXLIB dxif (true); // select software serial

void setup() {
  // set terminal baudrate
  Serial.begin (9600);

  // set dxlib baudrate
  dxif.begin (57143);

  // Torque off
  dxif.WriteByteData (1, 24, 0, NULL);
}

void loop() {
  uint16_t ppos;

  // Get present position
  dxif.ReadWordData (1, 36, &ppos, NULL);
  Serial.println (ppos, DEC);

  delay (100);
}
