// Get Present Position
//  Torque off and get present position for XM430/XH430
//  Since software serial is selected, dynamixel should be use at 57600bps or less.
//  1.select [SOFT]
//  2.compile & download

#include <dx2lib.h>
#include <SoftwareSerial.h>

DX2LIB dxif (true); // select software serial

void setup() {
  // set terminal baudrate
  Serial.begin (9600);

  // set dxlib baudrate
  dxif.begin (57600);

  // Torque off
  dxif.WriteByteData (1, 64, 0, NULL);
}

void loop() {
  int32_t ppos;

  // Get present position
  dxif.ReadLongData (1, 132, (uint32_t *)&ppos, NULL);
  Serial.println (ppos, DEC);

  delay (100);
}
