// Set Goal Position
//  Move position to the full range for XM430/XH430
//  Since software serial is selected, dynamixel should be use at 57600bps or less.
//  1.select [SOFT]
//  2.compile & download

#include <dx2lib.h>
#include <SoftwareSerial.h>

DX2LIB dxif (true); // select software serial

int32_t maxpos, minpos, gpos = 0;

void setup() {
  dxif.begin (57600);

  // Get max/min position limit
  dxif.ReadLongData (1, 48, (uint32_t *)&maxpos, NULL);
  dxif.ReadLongData (1, 52, (uint32_t *)&minpos, NULL);

  // Torque on
  dxif.WriteByteData (1, 64, 1, NULL);

  // Get Present Position
  dxif.ReadLongData (1, 132, (uint32_t *)&gpos, NULL);

}

void loop() {
  static int32_t dir = 10;

  // Update target value
  gpos += dir;
  if (gpos >= maxpos) {
    gpos = maxpos;
    dir *= -1;
  } else if (gpos <= minpos) {
    gpos = minpos;
    dir *= -1;
  };

  // Set goal position
  dxif.WriteLongData (1, 116, gpos, NULL);

  delay (10);
}
