// Direct packet tx/rx
//  Since software serial is selected, dynamixel should be use at 57600bps or less.
//  1.select [SOFT]
//  2.compile & download

#include <dx2lib.h>
#include <SoftwareSerial.h>

DX2LIB dxif (true); // select software serial

int32_t maxpos, minpos, gpos = 0;

void setup() {
  Serial.begin (9600);

  dxif.begin (57600);
}

void loop() {
  static uint32_t d;
  static uint8_t led = 0;

  uint8_t buf[20], err;
  uint16_t len;

  // Tx Ping instruction (no parameter)
  if (dxif.TxPacket (1, 0x01, NULL, 0)) Serial.println ("Tx ping OK");
  else Serial.println ("Tx NG");
  // Rx Status packet
  if (dxif.RxPacket (buf, sizeof (buf), &len, &err)) {
    Serial.println ("Rx ping OK");
    for (int i = 0; i < len; i++) {
      Serial.print (buf[i], HEX);
      Serial.print (" ");
    }
    Serial.println ("");
  } else Serial.println ("Rx NG");

  // Tx Write instruction
  * (uint16_t *)&buf[0] = 65;
  buf[2] = led;
  if (dxif.TxPacket (1, 0x03, buf, 3)) Serial.println ("Tx write OK");
  else Serial.println ("Tx NG");
  // Rx Status packet
  if (dxif.RxPacket (buf, sizeof (buf), &len, &err)) Serial.println ("Rx write OK");
  else Serial.println ("Rx NG");
  led ^= 1;

  delay (1000);
}